/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago					Data di creazione : 30/03/2000
 * Codice   :
 *
 * Note:
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */


#ifndef		NTPFCOMTRACE_H
#define		NTPFCOMTRACE_H

#include	"ntdef.h"

extern	ULONG dw_TraceWTimer;

// Struttura per la gestione del trace.
// Attenzione !!! Questa struttura deve essere sincrona con PC_TRACEW_H8300_STR.
struct TRACE_STR
{
// Tenere le variabili di tipo UCHAR sempre in numero pari per
// evitare problemi di allineamento (H8300).
	UCHAR  by_en;        // Flag di abilitazione.
	UCHAR  by_lastEn;    // Flag ultimo stato abilitazione,(ad uso interno).

	ULONG dw_enTime;    // Contiene l'ora di abilitazione del trace.
						// Il tempo viene espresso in  in sample count.

	ULONG dw_disTime;   // Contiene l'ora di disabilitazione del trace.
						// Il tempo viene espresso in  in sample count.

	USHORT  w_size;       // Dimensione del trace.
	USHORT  w_itemCt;     // Contatore elementi inseriti nel trace.
	USHORT  w_value;      // Valore dell'ultimo elemento inserito nel trace.
	USHORT  w_averageSize;  // Numero elementi per il calcolo della media.
	ULONG 	dw_averageSum;  // Sommatoria degli elementi per il calcolo della media.
	USHORT  w_averageItemCt;// Contatore elementi inseriti nella sommatoria.


	USHORT* pw_averageOldItem; // Puntatore elemento piu' vecchio della sommatoria.
	USHORT* pw_itemFirst; 	 // Puntatore al primo elemento del trace.
	USHORT* pw_itemLast;  	 // Puntatore all'ultimo elemento del trace.
	USHORT* pw_itemIns;   	 // Puntatore all'ultimo elemento inserito nel trace.
	USHORT*	pw_items;        // Puntatore agli elementi della lista

	TRACE_STR(	USHORT  w_size,     // Dimensione del trace.
				USHORT  w_averageSize,// Numero di misure per il calcolo della media.
				UCHAR  by_en);      // Abilitazione.

	~TRACE_STR();

	void	AverageReset()
	{
		w_averageItemCt	=	0;
	}

	void	Clear()
	{
		w_itemCt	=	0;
	}

	void	Insert(USHORT	w_Value);
	void 	averageSumInsert();

	UCHAR  	Enable(UCHAR	by_Enable)
	{
		return	by_en=by_Enable;
	}

	UCHAR  	IsEnable()
	{
		return	by_en;
	}

	USHORT	Average()
	{
	// Se non ci sono elementi nella summatoria rendo 0.
		if(!w_averageItemCt)
			return(0);

	// Calcolo e rendo il valore medio
		return (USHORT)(dw_averageSum / w_averageItemCt);
	}

	void	ConvertH8300Trace();

	USHORT 	WordEndianSwap(USHORT inWord);
	ULONG 	DoubleWordEndianSwap(ULONG inDWord);
	void 	EndianSwap(UCHAR* pby_data, // Puntatore alla variabile da swappare
				UCHAR  size   );  // Dimensione della variabile.

};


//	L'H8 montato  a bordo della PCFOM usa un allineamento a WORD

#include	<pshpack2.h>

#pragma warning(disable : 4200)   // warning C4200: nonstandard extension used : zero-sized array in struct/union

// Struttura per la gestione dei trace ricevuti da schede con chip H8300.
// Attenzione !!! Questa struttura deve essere sincrona con PC_TRACEW_STR.
// Attenzione !!! Aggiornare anche la funzione PCTraceWH8300ToPC().
typedef struct PC_TRACE_H8300_STR
{
// Tenere le variabili di tipo UCHAR sempre in numero pari per
// evitare problemi di allineamento (H8300).
	UCHAR  by_en;        // Flag di abilitazione.
	UCHAR  by_lastEn;    // Flag ultimo stato abilitazione,(ad uso interno).

	ULONG dw_enTime;    // Contiene l'ora di abilitazione del trace.
						// Il tempo viene espresso in sample count.

	ULONG dw_disTime;   // Contiene l'ora di disabilitazione del trace.
						// Il tempo viene espresso in sample count.

	USHORT  w_size;       // Dimensione del trace.
	USHORT  w_itemCt;     // Contatore elementi inseriti nel trace.
	USHORT  w_value;      // Valore dell'ultimo elementi inserito nel trace.
	USHORT  w_averageSize;  // Numero elementi per il calcolo della media.
	ULONG 	dw_averageSum;  // Sommatoria degli elementi per il calcolo della media.
	USHORT  w_averageItemCt;// Contatore elementi inseriti nella sommatoria.

	USHORT 	pw_averageOldItem;// Puntatore elemento piu' vecchio della sommatoria.
	USHORT 	pw_itemFirst;  	// Puntatore al primo elemento del trace.
	USHORT 	pw_itemLast;   	// Puntatore all'ultimo elemento del trace.
	USHORT 	pw_itemIns;    	// Puntatore all'ultimo elemento inserito nel trace.
	USHORT	pw_items[0];	// Puntatore agli elementi della lista

}PC_TRACE_H8300_STR; 

#pragma warning(default : 4200)   // warning C4200: nonstandard extension used : zero-sized array in struct/union

//	Riporta l'allineamento come default

#include	<poppack.h>

// Struttura per la gestione del trace su PC
typedef struct PC_TRACE_PC_STR
{
// Tenere le variabili di tipo UCHAR sempre in numero pari per
// evitare problemi di allineamento (H8300).
	UCHAR  	by_en;        	// Flag di abilitazione.
	UCHAR  	by_lastEn;    	// Flag ultimo stato abilitazione,(ad uso interno).

	ULONG 	dw_enTime;    	// Contiene l'ora di abilitazione del trace.
							// Il tempo viene espresso in sample count.

	ULONG 	dw_disTime;   	// Contiene l'ora di disabilitazione del trace.
							// Il tempo viene espresso in sample count.

	USHORT  w_size;       	// Dimensione del trace.
	USHORT  w_itemCt;     	// Contatore elementi inseriti nel trace.
	USHORT  w_value;      	// Valore dell'ultimo elemento inserito nel trace.
	USHORT  w_averageSize;  	// Numero elementi per il calcolo della media.
	ULONG 	dw_averageSum;  	// Sommatoria degli elementi per il calcolo della media.
	USHORT  w_averageItemCt;	// Contatore elementi inseriti nella sommatoria.

	USHORT* pw_averageOldItem; // Puntatore elemento piu' vecchio della sommatoria.
	USHORT* pw_itemFirst; 	// Puntatore al primo elemento del trace.
	USHORT* pw_itemLast;  	// Puntatore all'ultimo elemento del trace.
	USHORT* pw_itemIns;   	// Puntatore all'ultimo elemento inserito nel trace.
	USHORT*	pw_items;       // Puntatore agli elementi della lista

}PC_TRACE_PC_STR;


#endif	//	NTPFCOMTRACE_H
