/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago					Data di creazione : 30/03/2000
 * Codice   :
 *
 * Note:
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */


#ifndef __NTPCFOMioctl__h_
#define __NTPCFOMioctl__h_

#define	NTPCFOM_MAX_VALUES		8
#define	NTPCFOM_MAX_XSUM_VALUES	2


#define NTPCFOM_IOCTL_GET_SINGLE_VALUE				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_GET_SINGLE_VALUE_BUFFER
{
	USHORT	w_Value;
	USHORT	w_Average;
}	NTPCFOM_IOCTL_GET_SINGLE_VALUE_BUFFER, *PNTPCFOM_IOCTL_GET_SINGLE_VALUE_BUFFER;

#define NTPCFOM_IOCTL_GET_SINGLE_MEDIA_SUM			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define NTPCFOM_IOCTL_GET_SINGLE_XSUM_VALUE			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_GET_SINGLE_XSUM_VALUES_BUFFER
{
	USHORT		w_SampleXSumCt;		// Numero di campioni presenti nel trace
	UINT128		ui128_SampleXSum; // Somma del prodotto tra i campioni dei canali 0 e 1

}	NTPCFOM_IOCTL_GET_SINGLE_XSUM_VALUES_BUFFER, *PNTPCFOM_IOCTL_GET_SINGLE_XSUM_VALUES_BUFFER;

#define NTPCFOM_IOCTL_GET_MULTIPLE_VALUES			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_GET_MULTIPLE_VALUES_BUFFER
{
	USHORT	w_Value[NTPCFOM_MAX_VALUES];
	USHORT	w_Average[NTPCFOM_MAX_VALUES];
}	NTPCFOM_IOCTL_GET_MULTIPLE_VALUES_BUFFER, *PNTPCFOM_IOCTL_GET_MULTIPLE_VALUES_BUFFER;

#define NTPCFOM_IOCTL_GET_MULTIPLE_MEDIA_SUM		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define NTPCFOM_IOCTL_GET_MULTIPLE_XSUM_VALUES		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_GET_MULTIPLE_XSUM_VALUES_BUFFER
{
	USHORT				w_SampleXSumCt;		// Numero di campioni presenti nel trace
	UINT128				ui128_SampleXSum[NTPCFOM_MAX_XSUM_VALUES]; // Somma del prodotto tra i campioni dei canali 0 e 1

}	NTPCFOM_IOCTL_GET_MULTIPLE_XSUM_VALUES_BUFFER, *PNTPCFOM_IOCTL_GET_MULTIPLE_XSUM_VALUES_BUFFER;


#define NTPCFOM_IOCTL_GET_SINGLE_TRACE_CONFIG		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_GET_SINGLE_TRACE_CONFIG_BUFFER
{
	USHORT				w_Address;        	// Indirizzo trace nella memoria della scheda PccFom.
	USHORT				w_Size;       		// Dimensione del trace.
	USHORT				w_AverageSize;  	// Numero elementi per il calcolo della media.
	USHORT				w_SamplingDivisor;	// Valore del divisore rispetto alla frequenza di campionamento
	UCHAR				by_InvertEnable;  	// Abilitazione alla inversione del valore campionato.
	UCHAR				by_ChannelEnable;	// Flag di abilitazione.
	
}	NTPCFOM_IOCTL_GET_SINGLE_TRACE_CONFIG_BUFFER, *PNTPCFOM_IOCTL_GET_SINGLE_TRACE_CONFIG_BUFFER;

#define NTPCFOM_IOCTL_GET_SINGLE_TRACE_ENABLE		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x807, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_SET_SINGLE_TRACE_ENABLE		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x808, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define NTPCFOM_IOCTL_GET_SINGLE_TRACE_INVERT		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x809, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_SET_SINGLE_TRACE_INVERT		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80A, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_SINGLE_STATUS_BUFFER
{
	USHORT	w_Index;
	USHORT	w_Value;
}NTPCFOM_IOCTL_SINGLE_STATUS_BUFFER, *PNTPCFOM_IOCTL_SINGLE_STATUS_BUFFER;

#define NTPCFOM_IOCTL_GET_SINGLE_TRACE				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80B, METHOD_BUFFERED, FILE_ANY_ACCESS)

#pragma warning(disable : 4200)   // warning C4200: nonstandard extension used : zero-sized array in struct/union
typedef	struct	_NTPCFOM_IOCTL_CHANNEL_TRACE_BUFFER
{
// Tenere le variabili di tipo UCHAR sempre in numero pari per
// evitare problemi di allineamento (H8300).

	UCHAR	by_En;			// Stato di abilitazione (r)

	ULONG	dw_EnTime;		// Contiene l'ora di abilitazione del trace.
							// Il tempo viene espresso in sample count (r)

	ULONG	dw_DisTime;		// Contiene l'ora di disabilitazione del trace.
							// Il tempo viene espresso in sample count (r)

	USHORT	w_Size;			// Dimensione del trace	(r/w)
	USHORT  w_ItemCt;		// Contatore elementi inseriti nel trace.
	USHORT  w_Value;		// Valore dell'ultimo elementi inserito nel trace.
	USHORT  w_AverageSize;	// Numero elementi per il calcolo della media.
	ULONG 	dw_AverageSum;	// Sommatoria degli elementi per il calcolo della media.
	USHORT  w_AverageItemCt;	// Contatore elementi inseriti nella sommatoria.

	USHORT	pw_Items[0];	// Puntatore agli elementi della lista dal piu' vecchio al piu' recente

}	NTPCFOM_IOCTL_CHANNEL_TRACE_BUFFER, *PNTPCFOM_IOCTL_CHANNEL_TRACE_BUFFER;

#pragma warning(default : 4200)   // warning C4200: nonstandard extension used : zero-sized array in struct/union

#define NTPCFOM_IOCTL_GET_MULTIPLE_TRACE_ENABLE		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80C, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_SET_MULTIPLE_TRACE_ENABLE		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80D, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_GET_MULTIPLE_TRACE_INVERT		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80E, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_SET_MULTIPLE_TRACE_INVERT		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80F, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef	struct	_NTPCFOM_IOCTL_MULTIPLE_STATUS_BUFFER
{
	USHORT	w_Value;
}	NTPCFOM_IOCTL_MULTIPLE_STATUS_BUFFER, *PNTPCFOM_IOCTL_MULTIPLE_STATUS_BUFFER;


#define NTPCFOM_IOCTL_RESET_TRACES_TIMER			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x810, METHOD_NEITHER, FILE_ANY_ACCESS)

#define NTPCFOM_IOCTL_GET_SAMPLING_DIVISOR_VALUE	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x811, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_SET_SAMPLING_DIVISOR_VALUE	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x812, METHOD_BUFFERED, FILE_ANY_ACCESS)
typedef	struct	_NTPCFOM_IOCTL_SAMPLE_DIVISOR_VALUE_BUFFER
{
	USHORT	w_Index;
	USHORT	w_SampleDivisorValue;

}	NTPCFOM_IOCTL_SAMPLE_DIVISOR_VALUE_BUFFER, *PNTPCFOM_IOCTL_SAMPLE_DIVISOR_VALUE_BUFFER;


#define NTPCFOM_IOCTL_RESET							CTL_CODE(FILE_DEVICE_UNKNOWN, 0x813, METHOD_NEITHER, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_RESTART						CTL_CODE(FILE_DEVICE_UNKNOWN, 0x814, METHOD_NEITHER, FILE_ANY_ACCESS)

#define NTPCFOM_IOCTL_GET_FIRMWARE_ID				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x815, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	NTPCFOM_FIRMWARE_ID_MAX_LEN	0x80
typedef	struct	_NTPCFOM_IOCTL_FIRMWARE_ID_BUFFER
{
	UCHAR	by_Buffer[NTPCFOM_FIRMWARE_ID_MAX_LEN];
}	NTPCFOM_IOCTL_FIRMWARE_ID_BUFFER, *PNTPCFOM_IOCTL_FIRMWARE_ID_BUFFER;


#define NTPCFOM_IOCTL_GET_FIRMWARE_VER				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x816, METHOD_BUFFERED, FILE_ANY_ACCESS)
typedef	struct	_NTPCFOM_IOCTL_FIRMWARE_VER_BUFFER
{
	USHORT	w_MajorVersion;
	USHORT	w_MinorVersion;

}	NTPCFOM_IOCTL_FIRMWARE_VER_BUFFER, *PNTPCFOM_IOCTL_FIRMWARE_VER_BUFFER;

#define NTPCFOM_IOCTL_GET_FOM_MODE	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x817, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define NTPCFOM_IOCTL_SET_FOM_MODE	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x818, METHOD_BUFFERED, FILE_ANY_ACCESS)

#endif
